/*
 * CFileMovieCore.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * This file was taken from Audioswitch package and modified in order
 * to work with samygodca
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __CFILEMOVIECORE_HPP__
#define __CFILEMOVIECORE_HPP__

#include "Config.h"
#include "Logging.h"
#include "CMovieCore.hpp"
#include "PCMem.hpp"

class LIB_EXPORT CFileMovieCore : public CMovieCore
{
private:
public:
	virtual ~CFileMovieCore();
	virtual int Open(char *, Multimedia::_tMediaInfoContext *);
	virtual int Play(Multimedia::VIDEO_INFO *, Multimedia::AUDIO_INFO *, unsigned char *, MediaCommon::DRM_INFO *, DecodeBuffer *);
	virtual int Stop(void);
	virtual int Pause(void);
	virtual int Resume(void);
	virtual int Close(void);
	virtual int GetCurPosition(void);
	/* 4x CMovieCore */
	virtual int Skip(int, long long, long long, long long *);
	virtual int Forward(float);
	/* 8x CMovieCore */
	virtual int CallbackChaptering(unsigned int, unsigned int, MediaCommon::CaptureEncoding, void *, void (*)(unsigned int, unsigned int, unsigned int, MediaCommon::CaptureEncoding, unsigned int, unsigned char *, void *));
	/* 11x CMovieCore */

	static void * Create(void);
	int EndPlay(void *);
	int BeginPlay(void *);
	void ErrorPlay(CMovieTDIF::_ErrorInfo, void *);
	void UnmuteCallback(TDiMpeg::TDAVDec_VideoInfo_t, void *);
	void ResChangeCallback(TDiMpeg::TDAVDec_VideoInfo_t, void *);
	CFileMovieCore(void);

};


#endif
