/*
 * PCSemaphore.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __PCSEMAPHORE_H__
#define __PCSEMAPHORE_H__

#include <pthread.h>
#include "Config.h"

class
#if __FOR_INJECTION__
DLL_LOCAL
#else
DLL_PUBLIC
#endif
	PCSemaphore
{
private:
	struct 	_tPCSemaphore {
		pthread_cond_t condition;
		int	m_CreateValue;
	};
	struct _tPCSemaphore * Semaphore;

public:
	/* PCSemaphore(void); */
	virtual ~PCSemaphore(void);
	void Give( void );
	void Take( void );
	int Try( unsigned long );
	void Destroy( void );
	int Create( int );
};


#endif

