/*
 * PCTask.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __PCTASK_H__
#define __PCTASK_H__

#include "Config.h"

enum PTEvent {
	PTEvent_NONE,
};

class LIB_EXPORT PCTask
{
private:
	int Protocol;
	int MediaType;
public:
	virtual int t_Create(void)
	{
		return 1;
	}
	virtual void t_Idle(void){}
	virtual void t_Destroy(void){}
	virtual int t_OnExit(PTEvent const *)
	{
		return 1;
	}
	virtual int t_OnUser(PTEvent const *)
	{
		return 1;
	}
	void OnPing(PTEvent const *);
	int t_OnEvent(PTEvent const *);
	void GetEventCallback(int, bool (**)(PTEvent  const*, void  const*), bool (**)(PTEvent  const*, void  const*), void  const**);
	void SetEventCallback(int, bool (*)(PTEvent  const*, void  const*), bool (*)(PTEvent  const*, void  const*), void  const*);
	void ExecuteEvent(void);
	void t_Main(void);
	void Send(PTEvent *, bool, bool);
	void Ping(unsigned long);
	void Destroy(void);
	void Create(char  const*, unsigned int, unsigned long);
	void OnExit(PTEvent const *);
	void OnUser(PTEvent const *);
	void Ping(PCTask*, unsigned long);
	~PCTask();
	/* PCTask(); */
}; 

#endif

