/*
 * TDiVideoEnhancer.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __TDIVIDEOENHANCER_HPP__
#define __TDIVIDEOENHANCER_HPP__

#include "Config.h"
#include "TDiObject.hpp"

enum TDColorFormat_k {
	TDCF_DUMMY = 0
};
enum TDSource_k {
	TDSRC_DUMMY = 0
};
enum TDCalibrationMode_k {
	TDCM_DUMMY = 0
};
enum TDCalibrationState_k {
	TDCS_DUMMY = 0
};

struct TDRect_t {
	int Dummy;
};

struct TDColor_t {
	int Dummy;
};





class LIB_EXPORT TDiVideoEnhancer : public TDiObject
{
public:
	enum TDVideoEnhancerModeType_k {
		EM_DUMMY = 0
	};
	enum TDVideoEnhancerAutoMotionType_k {
		AM_DUMMY = 0
	};
	enum TDPictureMode_k {
		PM_DUMMY = 0
	};
	enum TDVideoEnhancerDigitalNRType_k {
		NR_DUMMY = 0
	};
	enum TDVideoEnhancerColorSpaceType_k {
		CS_DUMMY = 0
	};
	enum TDColorTone_k {
		TDCOLORTONE_DUMMY = 0
	};
	enum TDVideoEnhancerLevelType_k {
		TDV1_DUMMY = 0
	};
	enum TDVideoEnhancerColorType_k {
		TDV2_DUMMY = 0
	};
	enum TDPictureExtension_k {
		TDPICEX_DUMMY = 0
	};
	enum TDDynamicControl_k {
		TDDYNCTRL_DUMMY = 0
	};
	enum TDDemoType_k {
		TDDEMOTYPE_DUMMY = 0
	};
	struct TDAutoMotionPlus_t {
		int Dummy;
	};
	struct TDVideoSpreadSpectrum_t {
		int Dummy;
	};
	struct TDWhiteBalance_t {
		int Dummy;
	};
	struct TDVideoSourceResInfo_t {
		int Dummy;
	};



	virtual ~TDiVideoEnhancer();
	virtual int SetProcessingColorFormat(TDColorFormat_k,bool);
	virtual int SetEnhanceMode(TDiVideoEnhancer::TDVideoEnhancerModeType_k,TDRect_t *);
	virtual int SetAutoMotionPlus(TDiVideoEnhancer::TDVideoEnhancerAutoMotionType_k,TDiVideoEnhancer::TDAutoMotionPlus_t  const*);
	virtual int SetTestPattern(uchar);
	virtual int SetSpreadSpectrum(TDiVideoEnhancer::TDVideoSpreadSpectrum_t &);
	virtual int SetContrast(int);
	virtual int SetBright(int);
	virtual int SetSharpness(int,int);
	virtual int SetColor(int,int);
	virtual int SetTint(int,int);
	virtual int SetColorTone(TDiVideoEnhancer::TDColorTone_k,TDiVideoEnhancer::TDPictureMode_k);
	virtual int SetDigitalNR(TDiVideoEnhancer::TDVideoEnhancerDigitalNRType_k,int);
	virtual int SetBlueOnlyMode(bool,int,int);
	virtual int SetBlackAdjust(TDiVideoEnhancer::TDVideoEnhancerLevelType_k);
	virtual int SetGamma(int);
	virtual int SetColorSpaceMode(TDiVideoEnhancer::TDVideoEnhancerColorSpaceType_k);
	virtual int SetColorSpaceCustomData(TDiVideoEnhancer::TDVideoEnhancerColorType_k,TDColor_t &);
	virtual int SetWhiteBalance(TDiVideoEnhancer::TDWhiteBalance_t &);
	virtual int SetFleshTone(int);
	virtual int SetEdgeEnhance(bool);
	virtual int SetDynamicContrast(TDiVideoEnhancer::TDVideoEnhancerLevelType_k);
	virtual int SetWideColorEnhance(TDSource_k,TDiVideoEnhancer::TDPictureMode_k);
	virtual int CheckCalibration(TDCalibrationMode_k,TDCalibrationState_k *);
	virtual int DoCalibration(TDCalibrationMode_k,TDCalibrationState_k);
/*
.rodata:016943EC 14 15 53 00                 DCD __cxa_pure_virtual
.rodata:016943F0 14 15 53 00                 DCD __cxa_pure_virtual
.rodata:016943F4 14 15 53 00                 DCD __cxa_pure_virtual
.rodata:016943F8 14 15 53 00                 DCD __cxa_pure_virtual
.rodata:016943FC 14 15 53 00                 DCD __cxa_pure_virtual
*/
	virtual int TDiVideoEnhancerPureVirt1(int) = 0;
	virtual int TDiVideoEnhancerPureVirt2(int) = 0;
	virtual int TDiVideoEnhancerPureVirt3(int) = 0;
	virtual int TDiVideoEnhancerPureVirt4(int) = 0;
	virtual int TDiVideoEnhancerPureVirt5(int) = 0;
	virtual int SetPictureInformation(TDiVideoEnhancer::TDVideoSourceResInfo_t  const*);
	virtual int GetPowerIndicator(int *);
	virtual int SetPictureExtension(TDiVideoEnhancer::TDPictureExtension_k,bool);
	virtual int SetDynamicControl(TDiVideoEnhancer::TDDynamicControl_k,bool);
	virtual int SetFRCTextScroll(bool);
	virtual int SetPDPDemoTextScroll(TDiVideoEnhancer::TDDemoType_k,bool);
	virtual int SetSmoothMotionDemo(bool);
	virtual int SetVideoSignalActivity(bool);
	virtual int SetFRCBorderMode(int);
	virtual int SetScartRGBVideoSignalTypeInfo(int);
	virtual int SetBackLightControl(bool);

	TDiVideoEnhancer(void);

};


#endif

