/*
 * TdBuilder.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __TDBUILDER_H__
#define __TDBUILDER_H__

#include <stdio.h>
#include <stdlib.h>

#include "TDiVideoEnhancer.hpp"

namespace TDBuilder LIB_EXPORT
{
	struct TDiObject {
		// 0x00
		void * m_TDaStore;
		void * m_Res04;
		void * m_Res08;
		void * m_Res0C;
		// 0x10
		void * m_Res10;
		void * m_Res14;
		void * m_TDaTunerAlpsSI2165;
		void * m_TDaAudioProcessor;
		// 0x20
		void * m_TDaAudioAmp0;
		void * m_TDaAudioAmp1;
		void * m_TDaSystem;
		void * m_TDaScaler0;
		// 0x30
		void * m_TDaScaler1;
		void * m_TDaAnalogVideoProcessor;
		void * m_TDaDemodulatorSI2165Alps;
		void * m_TDaDemux0;
		// 0x40
		void * m_TDaDemux1;
		void * m_Res44;
		void * m_Res48;
		void * m_Res4C;
		// 0x50
		void * m_Res50;
		void * m_TDaHdmiSwitch;
		void * m_Res58;
		void * m_Res5C;
		// 0x60
		TDiVideoEnhancer * m_TDiVideoEnhancer;
		void * m_Res64;
		void * m_Res68;
		void * m_Res6C;
		// 0x70
		void * m_Res70;
		void * m_Res74;
		void * m_Res78;
		void * m_Res7C;
		// 0x80
		void * m_TDaTunerSemcoSI2165;
		void * m_TDaTuner;
		void * m_TDaDemodulatorSI2165;
		void * m_TDaDemodulator;
		// 0x90
		void * m_TDaTunerTS;
		void * m_TDaDemodulatorTS;
		void * m_TDaTunerSemcoTCS;
		void * m_TDaDemodulatorTCS;
	};
	PUBLIC TDiVideoEnhancer * GetTDiVideoEnhancer(int);	/* TODO: should return TDaVideoEnhancer class */
	TDiMpeg * GetTDiMpeg( int );
	TDiDemux * GetTDiDemux( int );
}

#endif
