/*
 * audioswitch_inj.hpp
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * This file was taken from Audioswitch package and modified in order
 * to work with samygodca
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __AUDIOSWITCH_INJ_HPP__
#define __AUDIOSWITCH_INJ_HPP__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <dlfcn.h>
#include <sys/mman.h>

#include "Config.h"
#include "Multimedia.hpp"
#include "uldAvfdInterfacer.h"
#include "spIAe.h"
#include "uldAvfdMkvControl.h"
#include "CParsingMedia.hpp"
#include "CFileMovieCore.hpp"

/* ffmpeg includes */
#include <libavcodec/avcodec.h>

#define FUNC_FILEMOVIECORE2_IN "[CFileMovieCore2] %s In"
#define FUNC_FILEMOVIECORE2_OUT "[CFileMovieCore2] %s Out" 

class  LIB_EXPORT CFileMovieCore2 : public CFileMovieCore
{
private:
public:
	int Stop2( void );
};

#ifdef __cplusplus
extern "C" {
#endif

static int Multimedia_MediaPlayer_Movie_CMovie_SetStreamId(int * CMovie_this);
extern int Multimedia_MediaPlayer_Movie_CMovie_GetAudioInfo(int * CMovie_this, struct Multimedia::_tMediaInfoContext * media_info, int stream_index);
extern int CMovieCore_SetMediaInfo( CMovieCore * , Multimedia::_tMediaInfoContext * );

//extern int CFileMovieCore_Stop( CFileMovieCore * this_cm );
extern int CFileMovieCore2_Stop2( CFileMovieCore2 * Instance );

extern int spIAvfd_ChangeAudio( struct avfd_instance_t *, int, int ); 

extern int dca_process_keyproc(void);
	
#ifdef __cplusplus
}
#endif

#endif 
