#ifndef __SPIAVFDSTREAM_H__
#define __SPIAVFDSTREAM_H__

#include "uldAvfdInterfacer.h"
#include "Config.h"

#ifdef __cplusplus
extern "C" {
#endif
LIB_EXPORT int spIAvfd_Abort(int);
LIB_EXPORT int spIAvfd_StopAudioTransfer(int);
LIB_EXPORT int spIAvfd_SetDrmInfo(int);
LIB_EXPORT int spIAvfd_Close(int);
LIB_EXPORT int spIAvfd_Open(int, struct avfd_instance_t **);
LIB_EXPORT int modAvfd_GetSTC(int,int);
LIB_EXPORT int spIAvfd_SetFrameKeys(int,int);
LIB_EXPORT int spIAvfd_Configure( struct avfd_instance_t *, int * );
LIB_EXPORT int spIAvfd_StopVideoTransfer(int);
LIB_EXPORT int spIAvfd_TransferVideoData(int,int,int,int,int);
LIB_EXPORT int spIAvfd_TransferAudioData(int,int,int,int,int);
LIB_EXPORT int spIAvfd_InitVideoBuffer(int,int);
LIB_EXPORT int spIAvfd_InitAudioBuffer(int,int);
LIB_EXPORT int spIAvfd_GetFileOffsetByTime(int,int,int);
LIB_EXPORT int spIAvfd_Resume(int);
LIB_EXPORT int spIAvfd_Pause(int);
LIB_EXPORT void staAvfd_DemuxTask(void *);
LIB_EXPORT int spIAvfd_IsSeekable(struct avfd_instance_t *);
LIB_EXPORT int spIAvfd_SetPos(int,int,int,int);
LIB_EXPORT int spIAvfd_SetContainerInfo( struct avfd_instance_t *, int * );
LIB_EXPORT int spIAvfd_ChangeSubtitle( struct avfd_instance_t *, int, int );
LIB_EXPORT int spIAvfd_ChangeAudio( struct avfd_instance_t *, int, int );
LIB_EXPORT int spIAvfd_Start(struct avfd_instance_t *, int);
LIB_EXPORT int spIAvfd_SetSpeed(int,int,int);
LIB_EXPORT int spIAvfd_Stop(void);
LIB_EXPORT int spIAvfd_ParseIndex(struct avfd_instance_t *);

LIB_EXPORT int staAvfd_InvokeCallback(int);
LIB_EXPORT int spIAvfd_UnRegisterCallback(int,int,int);
LIB_EXPORT int spIAvfd_RegisterCallback(int,int,int,int);
LIB_EXPORT int avfd_GetStreamingBufferSize(int,int,int);
LIB_EXPORT int avfd_GetStreamPos(int);
PUBLIC int avfd_StreamDiscard(struct avfd_instance_t *);
LIB_EXPORT int avfd_StreamReleaseBlock(int);
LIB_EXPORT int avfd_ReleaseBufferTillOffset(int,int,int,int);
LIB_EXPORT int avfd_SetStreamBufferingOn(int,int);
LIB_EXPORT int avfd_SetBufferReConfigure(int,int);
LIB_EXPORT int avfd_SetStreamPos(int,int,int,int);
LIB_EXPORT int avfd_ReadStreamData(int,int,int,int);
LIB_EXPORT int avfd_SeekStream(int,int,int,int);
LIB_EXPORT int spIAvfd_SetStreamEnd(int);
LIB_EXPORT int spIAvfd_SubmitBuffer(int,int);
LIB_EXPORT int spIAvfd_GetBuffer(int,int,int,int);
LIB_EXPORT int spIAvfd_StreamBufConfigure(int,int,int,int);
LIB_EXPORT int spIAvfd_CloseStream(struct avfd_instance_t *);
LIB_EXPORT int spIAvfd_OpenStream(int);
#ifdef __cplusplus
}
#endif

#endif
