/*
 * SamyApp loader.
 */

#include <stdio.h>
#include <dlfcn.h>
#include "common.h"

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	char s[MAX_PATH];
	unsigned *handle;
	int (*ex_mod_init)(const char *);

	/*
     * Just load "mod.so" with RTLD_NODELETE and call the library
     * init function mod_init(). All the work should be done by
     * mod_init().
     */

 	snprintf(s, sizeof(s), "%s%s", path, "loader.log");
 	samyapp_log_init(s);

	snprintf(s, sizeof(s), "%s%s", path, "mod.so");
	if ((handle = dlopen(s, RTLD_NOW | RTLD_GLOBAL | RTLD_DEEPBIND | RTLD_NODELETE)) == NULL) {
		LOG("Cannot open[%s]: %s", s, dlerror());
		return (0);
	}

	ex_mod_init = dlsym(handle, "core_init");
	dlclose(handle);
	if (ex_mod_init == NULL || ex_mod_init(path) < 0) {
		LOG("Cannot initialize modules library[%s]", s);
		return (0);
	}
	LOG("Modules library[%s] initialized", s);
	samyapp_log_deinit();

	return 1;
}
