/*
 * copyright (c) 2004 Michael Niedermayer <michaelni@gmx.at>
 *
 * This file is part of FFmpeg.
 *
 * FFmpeg is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * FFmpeg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FFmpeg; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/**
 * @file
 * bitstream reader API header.
 */

#ifndef AVCODEC_GET_BITS_H
#define AVCODEC_GET_BITS_H

/* cut by sorcerer */

/* bit input */
/* buffer, buffer_end and size_in_bits must be present and used by every reader */
typedef struct GetBitContext {
    const uint8_t *buffer, *buffer_end;
/* #ifdef ALT_BITSTREAM_READER */
    int index;

/* #elif defined LIBMPEG2_BITSTREAM_READER */
/*     uint8_t *buffer_ptr; */
/*     uint32_t cache; */
/*     int bit_count; */
/* #elif defined A32_BITSTREAM_READER */
/*     uint32_t *buffer_ptr; */
/*     uint32_t cache0; */
/*     uint32_t cache1; */
/*     int bit_count; */
/* #endif */
    int size_in_bits;
} GetBitContext;

/* cut by sorcerer */

#endif /* AVCODEC_GET_BITS_H */
