#include "mod_default_source.h"

static struct cfg_enum_entry ctl_default_source[] = {
	{"OFF",       0},
	{"TV",        KEY_SOURCE_TV},
	{"EXT1",      KEY_SOURCE_EXT1},
	{"EXT2",      KEY_SOURCE_EXT2},
	{"PC",        KEY_SOURCE_PC},
	{"AV",        KEY_SOURCE_AV},
	{"COMPONENT", KEY_SOURCE_COMPONENT},
	{"HDMI1",     KEY_SOURCE_HDMI1},
	{"HDMI2",     KEY_SOURCE_HDMI2},
	{"HDMI3",     KEY_SOURCE_HDMI3},
	{"DVI",       KEY_SOURCE_HDMI3},
	{"HDMI4",     KEY_SOURCE_HDMI4},
	{NULL, 0}
};

struct default_source_config config = {
	.default_source = 0x0,
};

static struct mod_config_var config_vars[] = {
	{"DEFAULT_SOURCE",  0, ENUM_ENTRY(config.default_source, ctl_default_source)},
	{LAST_VAR_ENTRY}
};

int
mod_keypressed(const int *keys, int keys_num, int *key_out)
{
	if (!config.default_source)
		return (MOD_KEYPRESSED_UNKNOWN);

	if (keys[0] != KEY_SOURCE)
		return (MOD_KEYPRESSED_UNKNOWN);
	
	if (keys[1] == config.default_source || keys[1] == KEY_SOURCE)
		return (MOD_KEYPRESSED_UNKNOWN);

	*key_out = config.default_source;
	LOG("Set default source[%d]", *key_out);
	return (MOD_KEYPRESSED_PROCESSED);
}

const struct mod_config_var *
mod_get_config_vars(void)
{
	return (config_vars);
}
